private import responser;
private import typical_responses;
private import response;
private import request;
private import log;
private import attohttpd;
private import myio;
private import filter;

private import std.file;
private import std.string;

version (USE_CACHE_RESPONSER) {

private bool onlineMode;

class CacheResponser : Responser {
public:
    this() {
        onlineMode = AttoHttpd.self.conf.get("CacheOnlineMode").integer != 0;
        switchURI =
            "http://localhost:" ~ tostr(AttoHttpd.self.port) ~
            "/sys/switchCache";
    }

	override HttpResponse response(HttpRequest req) {
        if (req.isLocal) {
            if (req.localFile != `sys/switchCache`) return null;

            onlineMode = !onlineMode;
            return TypicalResponses.resOK(
                "server becomes " ~ ((onlineMode) ? "online." : "offline."));
        }

        if (onlineMode) return null;

        with (req) {
            char[] schema = "http";
            char[] f = "cache/" ~ schema ~ "/" ~ requestHost ~ "/" ~ localFile;

            // fuck!
            try {
                try {
                    if (isdir(f)) {
                        f ~= "_";
                    }
                }
                catch (Object o) {}
                if (!isfile(f)) return null;
            }
            catch (Object o) {
                return null;
            }

            char[] all = cast(char[])read(f);
            HttpResponse res = HttpResponse.createFromFullResponse(all);

            char[] type = res.header[`content-type`];
            if (type == `text/html`) {
                res.messageBody =
                    "it's cache. " "<a href=\"" ~ switchURI ~
                    "\">switching</a><hr>" ~ res.messageBody;
            }

            return res;
        }
	}

private:
    char[] switchURI;
}

class CacheFilter : Filter {
    this() {
        mkdirp("cache/http");
    }

	override bool filter(HttpRequest req, inout HttpResponse res) {
        if (!onlineMode) return true;

        if (req.isLocal) return true;

        with (req) {
            char[] schema = "http";
            char[] dir = "cache/" ~ schema ~ "/" ~ requestHost ~ "/" ~ dirName;
            mkdirp(dir);

            char[] file = dir ~ "/" ~ baseName;
            if (baseName == "") {
                file ~= "_";
            }

            try {
                write(file, res.toString);
            }
            catch (Object o) {
                Log.warn("could not cache to " ~ file ~ ": " ~ o.toString());
            }

            Log.info("cached to " ~ file);
        }

        return true;
	}

private:
    void mkdirp(char[] d) {
        // fuck exception!
        try {
            if (isdir(d)) return;
        }
        catch (Object o) {
        }

        int i = rfind(d, '/');
        if (i != -1) {
            char[] nd = d[0..i];
            mkdirp(nd);
        }

        mkdir(d);
    }

}

}

