private import std.string;
private import std.conv;
private import std.c.stdio;

private import request;

version (USE_YAML_RESPONSER) {
	version = USE_EMBEDDED_CGI;
}

version (USE_EMBEDDED_CGI) {

// ֥饦΅ǥ󥰤ˤʤäƤޤ

char[][char[]] getCgiParams(HttpRequest req) {
	if (req.method == "GET") {
		return getCgiParamsImpl(req.queryString);
	}
	else if (req.method == "POST") {
		char[] b = req.messageBody;
		while (b.length > 0 &&
			   (b[b.length-1] == '\r' || b[b.length-1] == '\n'))
		{
			b = b[0..b.length-1];
		}
		return getCgiParamsImpl(b);
	}
	return null;
}

private char[][char[]] getCgiParamsImpl(char[] str) {
	char[][char[]] params;
	foreach (char[] elm; std.string.split(str, "&")) {
		int idx = std.string.find(elm, "=");
		if (idx != -1) {
			char[] key = elm[0..idx];
			char[] val = elm[idx+1..elm.length];
			key = urlDecode(key);
			val = urlDecode(val);
			params[key] = val;
		}
	}
	return params;
}

private char[] urlDecode(char[] str) {
	int idx;
	char[] dst;
	str = std.string.replace(str, "+", " ");
	while ((idx = std.string.find(str, "%")) != -1) {
		dst ~= str[0..idx];
		char[] c = str[idx+1..idx+3];
		int i;
		sscanf(std.string.toStringz(c), "%x", &i);
		dst ~= cast(char)(i);
		str = str[idx+3..str.length];
	}
	dst ~= str;
	return dst;
}

}
