module win32.guiddef;
import win32.windef;

// Handwriting...

align(1) struct GUID 
{ 
	DWORD Data1; 
	WORD  Data2; 
	WORD  Data3; 
	BYTE  Data4[8]; 
}
alias GUID CLSID;
alias GUID IID;
alias GUID* REFIID;

bit IsEqualGUID(GUID rguid1, GUID rguid2)
{
	return 
		((uint*) &rguid1)[0] == ((uint*) &rguid2)[0] &&
      ((uint*) &rguid1)[1] == ((uint*) &rguid2)[1] &&
      ((uint*) &rguid1)[2] == ((uint*) &rguid2)[2] &&
      ((uint*) &rguid1)[3] == ((uint*) &rguid2)[3];
}

